#!/usr/bin/python

# test python curses stuff

import curses, time
import select
execfile('TextEntry.py')
execfile('TextScroll.py')


def my_quote_on(entry):
    y, maxx = entry.get_status_line()
    entry.window.addstr(y, maxx-5, 'Quo')

def my_quote_off(entry):
    y, maxx = entry.get_status_line()
    entry.window.addstr(y, maxx-5, '---')

def my_insert_toggle(entry):
    y, maxx = entry.get_status_line()
    if entry.get_insert_mode():
        entry.window.addstr(y, maxx-9, 'Ins')
    else:
        entry.window.addstr(y, maxx-9, '---')
        
def my_height_change(entry):
    y, maxx = entry.get_status_line()
    entry._box.resize_bottom(y-1)
    entry.window.addstr(y, 0, '-' * maxx)
    if entry.get_insert_mode():
        entry.window.addstr(y, maxx-9, 'Ins')
    else:
        entry.window.addstr(y, maxx-9, '---')

def my_resize(entry):
    my_height_change(entry)
    entry._box.redraw()

def go_textentry(win):
    x = TextEntry(win, 1)
    x.set_expand(2, 5)

    y, maxx = x.get_status_line()
    win.addstr(y, 0, '-' * maxx)
    x.set_text('test line\003\177:)')
    x.redraw()

    box = TextScroll(win, 0, y-1)
    box.add('First line...')
    box.redraw()

    x._box = box
    
    ins = 1
    win.addstr(y, maxx-9, 'Ins')

    x.keymap['meta1-\x18'] = lambda key, x=x: x.reset()

    # set up signal handlers
    x.signals['quote-on'] = my_quote_on
    x.signals['quote-off'] = my_quote_off
    x.signals['insert-toggle'] = my_insert_toggle
    x.signals['height-change'] = my_height_change
    x.signals['resize'] = my_resize
    
    t = 0
    twirl = '^>v<'
    x.locate()
    while 1:
        try:
            select.select([0], [], [], 0.5)
        except select.error:
            pass
        
        while x.poll():
            if x.is_complete():
                box.add(x.get_text())
                if x.get_text() == '/quit':
                    raise 'goodbye!'
                x.reset()
            x.locate()

        y, maxx = x.get_status_line()
        win.addstr(y, 1, twirl[t])
        t = (t+1) % 4


# the curses.wrapper thing sounds nice, but doesn't exist in 1.5 !
try:
    stdscr = curses.initscr()
    curses.noecho()
    curses.raw()
    stdscr.keypad(1)
    stdscr.nodelay(1)
    stdscr.clear()
    time.sleep(1)
    go_textentry(stdscr)
finally:
    curses.nocbreak()
    curses.noraw()
    curses.echo()
    stdscr.keypad(0)
    curses.endwin()
